/*
	Intermediate model format for game meshes. GameMesh
	www.janvanderweg.com
	jan@janvanderweg.com
	
	- Final surface builder
	
	references:
	Lengyel, Eric. Computing Tangent Space Basis Vectors for an Arbitrary Mesh. Terathon Software 3D Graphics Library, 2001. http://www.terathon.com/code/tangent.html
*/ 

fn gmBuildSurfaces GS=
(
	numnodes = GS.NumNodes
	for gn = 1 to numNodes do
	(
		n = GS.gmNodes[gn]
		s = gmSurface()			--- a temp surface to hold data. This is used later to split a surface according to matid groups
		m = n.Mesh
		format "\tBuilding: % \n" n.MaxNode.name
		
		numverts = n.VertIndex.count
		s.NumVerts = numverts
		numtris = n.Tris.count
		s.NumTris = numtris
		
		sg_faceusingvert=#()
		
		for t = 1 to numtris do
		(
			-- find correct vert indices. No, don't think I can make this comment any more vague, sorry...
			--- Ok that was a really stupid idea....
		/*	tri = point3 \
				n.VertIndex[n.Tris[t][1]] \
				n.VertIndex[n.Tris[t][2]] \
				n.VertIndex[n.Tris[t][3]]
			*/
			--- this works!
			tri = n.Tris[t]
			tri -= 1
			--tri = ( n.Tris[t] - 1)
			append s.Tris tri
			
			if (getfacesmoothgroup m t) == 0 do
			(
				sg_faceusingvert[n.Tris[t][1]] = t
				sg_faceusingvert[n.Tris[t][2]] = t
				sg_faceusingvert[n.Tris[t][3]] = t
			)
		)
		for vindex = 1 to numverts do
		(
			--- Vertex position and uvw position
			vertex = gmVertex()
			maxvert = n.VertIndex[vindex]
			uvwv = n.TVertIndex[vindex]
			vertex.position = getVert m maxvert
			vertex.uvw = getTVert m uvwv
			
			--- vertex weights
			if GS.isAnimated do
			(
				vertex.boneindex = n.VertexWeightBones[maxvert]
				vertex.boneweight = n.VertexWeightValues[maxvert]
			)
			
			--- compile final vert normals
			normals=[0,0,0]
			tangents=[0,0,0]
			bitangents=[0,0,0]
			--- grab number of normals in maxvert normal struct
			normalstruct = n.Normals[maxvert]
			numnormals = normalstruct.normal.count
			--- grab bitarray of normals to filter for
			filtergroup = n.SmoothGroups[vindex]
					
			--- iterate through all normals on maxvert
			count = 0
			--format "numnormals: %\n" numnormals
			--format "\tFiltering for: % Face for this vert: %\n" filtergroup sg_faceusingvert[vindex]
			
			for normal = 1 to numnormals do
			(
				/* Should probably bring this part out of the for loop and first check if current index has no sgroups */
				if filtergroup.numberset == 0 and normalstruct.sgroup[normal].numberset == 0 do
				(
					whichnormal  = finditem normalstruct.faces sg_faceusingvert[vindex]
					--format "vert for this face: %\n" normalstruct.faces
					--format "\t\tno sgroup using face: %\n" sg_faceusingvert[vindex]
					--format "\t\t%\t%\t%\n" normalstruct.normal[normal] normalstruct.tangent[normal] normalstruct.bitangent[normal]
					--format "\t\t%\t%\t%\n" normalstruct.normal[whichnormal] normalstruct.tangent[whichnormal] normalstruct.bitangent[whichnormal]
					
					normals = normalstruct.normal[whichnormal]
					tangents = normalstruct.tangent[whichnormal]
					bitangents = normalstruct.bitangent[whichnormal]
					/*normals = normalstruct.normal[normal]
					tangents = normalstruct.tangent[normal]
					bitangents = normalstruct.bitangent[normal]*/
				)
				--format "\t\tcount: %, %\n" normalstruct.sgroup[normal] normalstruct.sgroup[normal].numberset
				--if  normalstruct.sgroup[normal].numberset == 0 do
				--(
				--	format "no sgroup\n"
				--)
				if ( filtergroup * normalstruct.sgroup[normal]).numberset > 0 do
				(
					--format "shared normals\n"
					/*normals += normalstruct.normal[normal]
					tangents += normalstruct.normal[normal]
					bitangents += normalstruct.normal[normal]*/
					normals += normalstruct.normal[normal]
					tangents += normalstruct.tangent[normal]
					bitangents += normalstruct.bitangent[normal]
					count += 1
				)
				/*found = SharesSmoothingGroup filtergroup normalstruct.sgroup[normal]
				if found == true do
				(
					normals += normalstruct.normal[normal]
					tangents += normalstruct.normal[normal]
					bitangents += normalstruct.normal[normal]
					count += 1
				)*/
			)
			
			if count != 0 then
			(
				vertex.normal = normalize( normals / count )
				vertex.tangent = normalize ( tangents /count )
				vertex.bitangent = normalize ( bitangents /count )
			)
			else
			(
				vertex.normal =  normals 
				vertex.tangent =  tangents 
				vertex.bitangent = bitangents 
			)
			
			
			append s.Vertex vertex
		)
		
		matidcount = 0
		if n.Material.isMultiMaterial then
		(
			for matid = 1 to n.MatIdsUsed.count do
			(
				if n.MatIdsUsed[matid] == true do
(
/* BUILD SURFACE USING MATID */
	facesusingmatid=#()
	
	oldlist=#()		-- 'old' reference to maxvert
	newlist=#()
	newfacevertindices=#()
	
	for tri = 1 to numtris do
	(
		if n.MatIds[tri] == matid do append facesusingmatid tri
	)
	for f = 1 to facesusingmatid.count do
	(
		face = facesusingmatid[f]
		faceindices = n.Tris[face]
		newindices=[0,0,0]
		
		for i = 1 to 3 do
		(
			--- Iterate through the indices of all faces using given matid
			--- todo: rewrite using appendifunique since it returns true if appended
			index = faceindices[i]
			found = finditem oldlist index
			if found > 0 then
			(
				newindices[i] = newlist[found]
			)
			else
			(
				append oldlist index
				--append newlist newlist.count			--- don't add + 1 this way to vert indices start at 0 instead of like in max at 1
				c = newlist.count + 1
				append newlist c
				newindices[i] = c
			)
		)
		append newfacevertindices newindices
	)
	
	newsurface = gmSurface()
	newsurface.NumVerts = newlist.count
	newsurface.NumTris = facesusingmatid.count
	newsurface.Material = n.Material.MaxMaterial[matid]
	
	--- copy oldverts into the new surface
	for i = 1 to oldlist.count do
		append newsurface.Vertex (copy s.Vertex[oldlist[i]])
	newsurface.Tris = newfacevertindices

	append GS.Surfaces newsurface
	matidcount += 1
/*END BUILD SURFACE USING MATID*/
)
			)
		format "(%)" matidcount
		)
		else
		(
			--- The node doesn't have a multisub material applied to it. Its using a single material so no need for further splitting. Add the entire surface to the surface list
			s.Material = n.Material.MaxMaterial
			append GS.Surfaces s
		)		
		format "\n"
	)
	format "\tBuilt % surfaces\n" GS.Surfaces.count
)

fn gmMergeSurfacesUsingSameMaterial GS=
(
	/* 	Each node has been turned into one or more surfaces now
		Time to merge surfaces using the same material */
	format "--- Merging surfaces using same material ---\n"
	
	surfacesusingnomaterial=#()		
	uniquematerials=#()
	surfacesusingmaterial=#()
	
	numsurfaces = GS.Surfaces.count
	
	for s = 1 to numsurfaces do
	(
		surface = GS.Surfaces[s]
		
		if surface.Material == undefined then
		(
			append surfacesusingnomaterial surface
		)
		else
		(
			material = surface.Material
			
			found = findItem uniquematerials material
			if found == 0 then
			(	-- Material not found yet, add it to the list of unique materials and add surface to uniquematerial index using array
				append uniquematerials material
				c = uniquematerials.count
				surfacesusingmaterial[c] = #()	-- create a new array to hold suface indexes using unique material
				append surfacesusingmaterial[c] surface
			)
			else
			(
				append surfacesusingmaterial[found] surface
			)
		)
	)
	format "\tSurfaces using no material: %\n" surfacesusingnomaterial.count
	
	for m = 1 to uniquematerials.count do
		format "\tUnique material: %\n" uniquematerials[m]
	
	/* Do actual merging */
	NewSurfaceList=#()
	if surfacesusingnomaterial.count > 0 do
	(	-- First merge all surfaces not using any material
		newsurface = gmSurface()
		newsurface.Material = undefined
		indexoffset = 0
		
		for s = 1 to surfacesusingnomaterial.count do
		( -- Grab next surface and add it to new surface
			nextsurface = surfacesusingnomaterial[s]
			join newsurface.Vertex nextsurface.Vertex
			
			for t = 1 to nextsurface.Tris.count do
			(
				tri = nextsurface.Tris[t]
				tri += indexoffset
				append newsurface.Tris tri
			)
			indexoffset += nextsurface.Tris.count
		)
		newsurface.numverts = newsurface.Vertex.count
		newsurface.numtris = newsurface.Tris.count
		append NewSurfaceList newsurface
	) 
	if uniquematerials.count > 0 do
	(   --- grab nex material and merge all surfaces using it
		for m = 1 to uniquematerials.count do
		(
			format "Merging material: %\n" uniquematerials[m]
			newsurface = gmSurface()
			newsurface.Material = uniquematerials[m]
			indexoffset = 0
			
			for s = 1 to surfacesusingmaterial[m].count do
			( -- Grab next surface and add it to new surface
				nextsurface = surfacesusingmaterial[m][s]
				join newsurface.Vertex nextsurface.Vertex
			
				for t = 1 to nextsurface.Tris.count do
				(
					tri = nextsurface.Tris[t]
					tri += indexoffset
					append newsurface.Tris tri
				)
				indexoffset += nextsurface.Tris.count
			)
			newsurface.numverts = newsurface.Vertex.count
			newsurface.numtris = newsurface.Tris.count
			append NewSurfaceList newsurface
		)
	)
	GS.Surfaces = NewSurfaceList
	GS.numSurfaces = GS.Surfaces.count
)
