/*
	Intermediate model format for game meshes. GameMesh
	www.janvanderweg.com
	jan@janvanderweg.com
	
	- Helper functions
	
	references:
	Lengyel, Eric. Computing Tangent Space Basis Vectors for an Arbitrary Mesh. Terathon Software 3D Graphics Library, 2001. http://www.terathon.com/code/tangent.html
*/ 

/* Generic Helpers */

/* Material Helpers */

/* Hierarchy Helpers */
fn FindRootBone node= 
(
	-- recursive root finder function. Works up all the parents to find the final rootbone for given node
	root = node
	
	if ( root.parent == undefined) then
	(
		return root
	)
	else
	(
		return FindRootBone root.parent
	)
)

/* Mesh helpers */
fn getFaceSmoothGroupB obj face =				-- Returns bitarray of used smoothing groups
(
	local sgroup_val=getFaceSmoothGroup obj face
	local sg_bitarray=#{}
	if sgroup_val < 0 do
	(
		sg_bitarray[32]=true
		sgroup_val -= 2^31
	)
	for i = 1 to 31 do
	(
		sg_bitarray[i]= (mod sgroup_val 2 > .5)
		sgroup_val /= 2
	)
	return sg_bitarray
)