/*
	Intermediate model format for game meshes. GameMesh
	www.janvanderweg.com
	jan@janvanderweg.com
	
	- Material subsection
	
	references:
	Lengyel, Eric. Computing Tangent Space Basis Vectors for an Arbitrary Mesh. Terathon Software 3D Graphics Library, 2001. http://www.terathon.com/code/tangent.html
*/ 
fn gmCollectMaterials GS=
(
	numnodes = GS.NumNodes
	format "--- Collecting materials for % nodes---\n" numnodes
	
	for i = 1 to numnodes do
	(
		node = GS.gmNodes[i].MaxNode
		format "\tNode: %\n" node
		mymat = gmMaterial()
		format "1\n"
		maxMaterial = node.material
		format "2\n"
		mymat.maxMaterial = node.material
		format "precheck stage\n"
		if classof maxMaterial == MultiMaterial then 
		(
			format "multimaterial..."
			mymat.isMultiMaterial = true
			mymat.isDummy = false
			format "done\n"
		)
		else if classof maxMaterial == StandardMaterial then 
		(
			format "standardmaterial..."
			mymat.isMultiMaterial = false
			mymat.isDummy = false
			format "done\n"
		)
		else
		(
			format "no material..."
			mymat.isMultiMaterial = false
			mymat.isDummy = true
			if true == GS.setting_missingmaterialiserror do
			(
				--- don't throw error for missing material.
				GS.isError = true
				GS.whatError = "CollectMaterials: Unknown material type applied to node: " + node.name
				return false
			)
			format "\t\tWarning: unknown material type applied to node '%'\n" node
		)
		format "finished checking stage\n"
		GS.gmNodes[i].Material = mymat
		--append GS.MaxMaterials mymat
		--GS.NumMaterials += 1
		if GS.setting_verbosematerial == true do mymat.DebugOut()
		format "done\n"
	)
)