/*
========================================

========================================
*/
/*
	SCA STRUCTS
*/
struct SC2_Header_SCA
(
	fourcc,			--"ANIM"
	version,		--"65"
	numFrames,
	duration,		--duration in seconds. fps: (numFrames-1)/duration
	numBones,
	boneNameOffset,
	boneLinkOffset,
	firstFrameOffset,
	frameSize
)

struct SC2_Frame_SCA
(
	position_array=#(),		--arrays holding relative position and rotation data
	rotation_array=#(),		--
	frame_time,			--float
	frame_flags,		--unsignedlong
	bones,				--number of bones in the frame
	--framesize,			-- = 4 * (( 7 * numbones ) + 2)
	
	fn WriteFrame bstream=
	(
		--write frame header
		WriteFloat bstream frame_time
		--no flags defined yet
		--WriteLong bstream frame_flags #unsigned
		WriteLong bstream 0 #unsigned
		
		for i = 1 to bones do
		(
			Position = position_array[i]
			WriteFloat bstream Position[1]
			WriteFloat bstream Position[2]
			WriteFloat bstream Position[3]
			
			Rotation = rotation_array[i]
			WriteFloat bstream Rotation.w 
			WriteFloat bstream Rotation.x 
			WriteFloat bstream Rotation.y 
			WriteFloat bstream Rotation.z 
		)
	),
	fn DebugOut frame bonenames fstream=
	(
		format "\nFrame: %\tTime: %\tFlags: %\n\n" frame frame_time frame_flags to:fstream
		for i = 1 to bones do
		(
			format "\t%: %\t Pos: %\t Rot:%\n" i bonenames[i] position_array[i] rotation_array[i] to:fstream
		)
	)
)

/* 
	SCM STRUCTS
*/
struct SC2_Header
(
	boneoffset,
	wbonecount,    
	vertoffset,
	evertoffset, --omitted in supcom1.0, leave as 0
	vertcount,
	indexoffset, 
	indexcount,
	infooffset, 
	infocount, 
	totalbones,
	xtraoffset,
	--xtravalue,
	materialoffset,
	materialnum,
	
	fn DebugOut=
	(
		format "SCM_Header\n----------\n"
		--format "Marker: %, version: %\n" fourcc version
		format "Weighted bones: %, Total bones: %\n" wbonecount totalbones
		format "Vertex count: %, Trianlge count: %\n" vertcount ( indexcount / 3 )
		format "bOffset: %, vOffset: %, tOffset: %, iOffset %, xOffset %\n" boneoffset vertoffset indexoffset infooffset xtraoffset
		ok
	)
)
struct SC2_Bonelist
(
	bones=#(),
	offset=#(),
	padding
)
struct SC2_Bone
(
	RestPoseInverse1, 	--4x4 Matrix with row major
	RestPoseInverse2,	--row2 
	RestPoseInverse3,	--row3
	RestPoseInverse4,	--row4
	Position,					--vector(x,z,y) pos relative to parent bone
	Rotation,				--quaternion(w,x,y,z) rot relative to parent bone
	nameoffset,			--long
	parentboneindex,		--long
	reserved0,				--long				
	reserved1,				--long
	name					--name
)
struct SC2_Vertex
(
	position,
	normal,
	tangent,
	bitangent,
	uv1,
	uv2,
	boneindex=#(),
	boneweights=#()
)