/*
========================================

========================================
*/

fn SC2_WriteHeader_SCA bstream H=
(
	format "Writing sca header...\n"
	WriteLong bstream H.fourcc #unsigned
	WriteLong bstream H.version #unsigned
	WriteLong bstream H.numFrames #unsigned
	WriteFloat bstream H.duration 
	WriteLong bstream H.numBones #unsigned
	WriteLong bstream H.boneNameOffset #unsigned
	WriteLong bstream H.boneLinkOffset #unsigned
	WriteLong bstream H.firstFrameOffset #unsigned
	WriteLong bstream H.frameSize #unsigned
	
	--pad
		WriteByte bstream 187
		WriteByte bstream 119
		WriteByte bstream 119
		WriteByte bstream 119
		WriteByte bstream 46
		WriteByte bstream 106
		WriteByte bstream 97
		WriteByte bstream 110
		WriteByte bstream 118
		WriteByte bstream 97
		WriteByte bstream 110
		WriteByte bstream 100
		WriteByte bstream 101
		WriteByte bstream 114
		WriteByte bstream 119
		WriteByte bstream 101
		WriteByte bstream 103
		WriteByte bstream 46
		WriteByte bstream 99
		WriteByte bstream 111
		WriteByte bstream 109
        WriteByte bstream 187
		WriteByte bstream 187
		WriteByte bstream 187

		WriteByte bstream 78
		WriteByte bstream 65
		WriteByte bstream 77
		WriteByte bstream 69
)

fn SC2_WriteBonelist_SCA bstream bonelist=
(
	format "Writing sca bonelist...\n"
	for i = 1 to bonelist.bones.count do Writestring bstream bonelist.bones[i]
	for i = 1 to bonelist.padding do WriteByte bstream 187
	WriteByte bstream 76 -- SKEL
	WriteByte bstream 73
	WriteByte bstream 78
	WriteByte bstream 75
)

fn SC2_WriteBonelinks_SCA bstream h padding=
(
	for i = 1 to h.count do
		WriteLong bstream h.parentindex[i] #unsigned
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 68 -- DATA
	WriteByte bstream 65
	WriteByte bstream 84
	WriteByte bstream 65
)
/*

fn SC2_WriteBonelist bstream bonelist=
(
	format "Writing bonelist...\n"
	for i = 1 to bonelist.bones.count do Writestring bstream bonelist.bones[i]
	for i = 1 to bonelist.padding do WriteByte bstream 187
	WriteByte bstream 83 -- SKEL
	WriteByte bstream 75
	WriteByte bstream 69
	WriteByte bstream 76
)

fn SC2_WriteBone bstream bone=
(
	WriteFloat bstream bone.RestPoseInverse1[1] 
	WriteFloat bstream bone.RestPoseInverse2[1] 
	WriteFloat bstream bone.RestPoseInverse3[1] 
	WriteFloat bstream 0.0 
	
	WriteFloat bstream bone.RestPoseInverse1[2] 
	WriteFloat bstream bone.RestPoseInverse2[2] 
	WriteFloat bstream bone.RestPoseInverse3[2] 
	WriteFloat bstream 0.0
	
	WriteFloat bstream bone.RestPoseInverse1[3] 
	WriteFloat bstream bone.RestPoseInverse2[3] 
	WriteFloat bstream bone.RestPoseInverse3[3] 
	WriteFloat bstream 0.0 
	
	WriteFloat bstream bone.RestPoseInverse4[1] 
	WriteFloat bstream bone.RestPoseInverse4[2] 
	WriteFloat bstream bone.RestPoseInverse4[3] 
	WriteFloat bstream 1.0 

	WriteFloat bstream bone.Position[1] 
	WriteFloat bstream bone.Position[2] 
	WriteFloat bstream bone.Position[3] 
	
	WriteFloat bstream bone.Rotation.w 
	WriteFloat bstream bone.Rotation.x 
	WriteFloat bstream bone.Rotation.y 
	WriteFloat bstream bone.Rotation.z 

	WriteLong bstream bone.nameoffset #unsigned
	WriteLong bstream bone.parentboneindex #unsigned
	
	WriteLong bstream 0 #unsigned
	WriteLong bstream 0 #unsigned
)

fn SC2_WriteBones bstream bones padding=
(
	format "Writing bone data: %\n" bones.count
	for i = 1 to bones.count do SC2_WriteBone bstream bones[i]
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 86 -- VTXL
	WriteByte bstream 84
	WriteByte bstream 88
	WriteByte bstream 76
)


fn SC2_WriteVert bstream vert=
(
	--position
		WriteFloat bstream vert.Position[1]
		WriteFloat bstream vert.Position[2]
		WriteFloat bstream vert.Position[3]
		--normal
		WriteFloat bstream vert.Normal[1]
		WriteFloat bstream vert.Normal[2]
		WriteFloat bstream vert.Normal[3]
		--tangent
		WriteFloat bstream vert.Tangent[1]
		WriteFloat bstream vert.Tangent[2]
		WriteFloat bstream vert.Tangent[3]
		--binormal
		WriteFloat bstream vert.Bitangent[1]
		WriteFloat bstream vert.Bitangent[2]
		WriteFloat bstream vert.Bitangent[3]
		--uv1
		WriteFloat bstream vert.uv1[1]
		WriteFloat bstream ( 1 - vert.uv1[2] )
		--uv2
		WriteFloat bstream vert.uv2[1]
		WriteFloat bstream ( 1 - vert.uv2[2] )
		--boneindex
		WriteByte bstream vert.boneindex[1] #unsigned
		WriteByte bstream vert.boneindex[2] #unsigned
		WriteByte bstream vert.boneindex[3] #unsigned
		WriteByte bstream vert.boneindex[4] #unsigned
)

fn SC2_WriteVerts bstream verts padding=
(
	format "Writing vert data...\n"
	for i = 1 to verts.count do SC2_WriteVert bstream verts[i]
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 84 -- TRIS
	WriteByte bstream 82
	WriteByte bstream 73
	WriteByte bstream 83
)
fn SC2_WriteSurfaceTris bstream tris offset=
(
	format "Writing surface tris data...\n"
	for i = 1 to tris.count do
	(
		WriteShort bstream ( tris[i][1] - 1 + offset ) #unsigned 
		WriteShort bstream ( tris[i][2] - 1 + offset ) #unsigned
		WriteShort bstream ( tris[i][3] - 1 + offset ) #unsigned
	)
)
fn SC2_WriteTrisPadding bstream padding=
(
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 88 -- XTRA
	WriteByte bstream 84
	WriteByte bstream 82
	WriteByte bstream 65
)
fn SC2_WriteTris bstream tris padding=
(
	format "Writing tris data...\n"
	for i = 1 to tris.count do
	(
		WriteShort bstream ( tris[i][1] - 0 ) #unsigned 
		WriteShort bstream ( tris[i][2] - 0 ) #unsigned
		WriteShort bstream ( tris[i][3] - 0 ) #unsigned
	)
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 88 -- XTRA
	WriteByte bstream 84
	WriteByte bstream 82
	WriteByte bstream 65
)
fn SC2_WriteXtra bstream verts padding=
(
	format "Writing Xtra data...\n"
	for i = 1 to verts.count do
	(
		vw = verts[i].boneweights
		WriteByte bstream vw[1] #unsigned 
		WriteByte bstream vw[2] #unsigned 
		WriteByte bstream vw[3] #unsigned 
		WriteByte bstream vw[4] #unsigned 
	)
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 73
	WriteByte bstream 78
	WriteByte bstream 70
	WriteByte bstream 79
)
fn SC2_WriteMATS bstream mdata offset numverts=
(
	tof = offset
	format "Writing Material data...\n"
	for i = 1 to mdata.count do
	(
		md = mdata[i]
		WriteLong bstream tof #unsigned  -- material name offset pointer
		tof += md[3]
		WriteLong bstream md[1] #unsigned  -- num tris
		WriteLong bstream md[2] #unsigned  -- start index
		WriteLong bstream md[4] #unsigned				-- vert reference number?
		WriteLong bstream md[5] #unsigned    -- number of verts ?
	)
)*/