/*
========================================

========================================
*/
fileIn "GameMesh/gmMain.ms"	-- gamemesh processor
filein "SupCom/supcom2export_scm.ms"
fileIn "Supcom/supcom2export_sca.ms"

utility SUPCOM2 "Supreme Commander 2 Maxtool" silentErrors:false
(
	group "About:"
	(
		--bitmap the_bmp fileName:"supcom.bmp" 
		label Label1 "SupCom2 MaxToodlesTool v1"
		label Label2 "www.janvanderweg.com"
	)
	group "Export:"
	(
		button ExportSCM "Export SCM" tooltip:"toodles"
		button ExportSCA "Export SCA" tooltip:"My Wife is illuminate!"
		button ParseSCM "Parse scm"
	)
	on ExportSCM pressed do
	(
		file = getSaveFileName caption:"Select export file" \
					filename:(getINISetting (scriptsPath + "Supcom/settings.ini") "settings" "exportscm") \
					types:"scm file (*.scm)|*.scm|All Files (*.*)|*.*|"
		
		if file != undefined then
		(
			setINISetting (scriptsPath + "Supcom/settings.ini") "settings" "exportscm" file
			set coordsys world
				
			local _gamemesh = gmMain()
			--_gamemesh.this = _gamemesh
			
			for i = 1 to selection.count do
				_gamemesh.AddNode(selection[i])
			
			if _gamemesh.isError do
			(
					messageBox _gamemesh.whatError title:"Game Mesh Error"
					format "1Error: %\n" _gamemesh.whatError
					return false
			)
			if _gamemesh.Go(true) == false then
			(
				if _gamemesh.isError then
				(
					messageBox _gamemesh.whatError title:"Game Mesh Error"
					format "2Error: %\n" _gamemesh.whatError
					return false
				)
				else
				(
					format "HELP Unknown error\n"
					return false
				)
			)
			ExportSupCom2Format _gamemesh file
			--jE_WriteStaticModelAscii _gamemesh file						
			
			max views redraw
			gc()
		)
	)
	on ExportSCA pressed do
	(
				file = getSaveFileName caption:"Select export file" \
					filename:(getINISetting (scriptsPath + "Supcom/settings.ini") "settings" "exportsca") \
					types:"sca file (*.sca)|*.sca|All Files (*.*)|*.*|"
		
		if file != undefined then
		(
			setINISetting (scriptsPath + "Supcom/settings.ini") "settings" "exportsca" file
			set coordsys world
				
			local _gamemesh = gmMain()
			--_gamemesh.this = _gamemesh
			
			for i = 1 to selection.count do
				_gamemesh.AddNode(selection[i])
			
			if _gamemesh.isError do
			(
					messageBox _gamemesh.whatError title:"Game Mesh Error"
					format "1Error: %\n" _gamemesh.whatError
					return false
			)
			if _gamemesh.Go(false) == false then
			(
				if _gamemesh.isError then
				(
					messageBox _gamemesh.whatError title:"Game Mesh Error"
					format "2Error: %\n" _gamemesh.whatError
					return false
				)
				else
				(
					format "HELP Unknown error\n"
					return false
				)
			)
			ExportSupCom2Format_Sca _gamemesh file
			--jE_WriteStaticModelAscii _gamemesh file						
			
			max views redraw
			gc()
		)
	)
	on ParseSCM pressed do
	(
	    scmFilename = getOpenFileName caption:"Select SCM file" \
					filename:(getINISetting (scriptsPath + "Supcom/settings.ini") "settings" "parsescm") \
					types:"SupCom SCM (*.scm)|*.scm|All Files (*.*)|*.*|"

		if scmFilename != undefined then
		(
				setINISetting (scriptsPath + "Supcom/settings.ini") "settings" "parsescm" scmFilename

				set coordsys world
					
				bstream = fopen scmFilename "rb"
				/* Read header */
				fourcc 		= ReadLong bstream #unsigned
				version 	= ReadLong bstream #unsigned
				boneoffset 	= ReadLong bstream #unsigned
				wbone 		= ReadLong bstream #unsigned
				
				vertoffset 	= ReadLong bstream #unsigned
				xtraoffset = ReadLong bstream #unsigned
				vertcount 	= ReadLong bstream #unsigned
				indexoffset = ReadLong bstream #unsigned
				
				indexcount 	= ReadLong bstream #unsigned
				infooffset 	= ReadLong bstream #unsigned
				infocount 	= ReadLong bstream #unsigned
				totalbones 	= ReadLong bstream #unsigned
				
				matoffset	= ReadLong bstream #unsigned
				nummats	= ReadLong bstream #unsigned
				tricount 	= ( indexcount / 3 )
				--tricount = 0
				highest = 0
				fseek bstream indexoffset #seek_set
				for f = 1 to indexcount do
				(
					value = Readshort bstream #unsigned
					if value > highest do highest = value
				)
				
				format "t: % - h: %\n" tricount highest
				
				fclose bstream
				max views redraw
		)
		
	)
)